<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑购物车' : '添加购物车'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="类型 0商城 1预定 " name="type">
        <a-input
          allow-clear
          placeholder="请输入类型 0商城 1预定 "
          v-model:value="form.type"
        />
      </a-form-item>
      <a-form-item label="商品ID" name="goodsId">
        <a-input
          allow-clear
          placeholder="请输入商品ID"
          v-model:value="form.goodsId"
        />
      </a-form-item>
      <a-form-item label="唯一标识" name="code">
        <a-input
          allow-clear
          placeholder="请输入商品唯一标识"
          v-model:value="form.code"
        />
      </a-form-item>
      <a-form-item label="商品数量" name="cartNum">
        <a-input
          allow-clear
          placeholder="请输入商品数量"
          v-model:value="form.cartNum"
        />
      </a-form-item>
      <a-form-item label="0 = 未购买 1 = 已购买" name="isPay">
        <a-input
          allow-clear
          placeholder="请输入0 = 未购买 1 = 已购买"
          v-model:value="form.isPay"
        />
      </a-form-item>
      <a-form-item label="是否为立即购买" name="isNew">
        <a-input
          allow-clear
          placeholder="请输入是否为立即购买"
          v-model:value="form.isNew"
        />
      </a-form-item>
      <a-form-item label="拼团id" name="combinationId">
        <a-input
          allow-clear
          placeholder="请输入拼团id"
          v-model:value="form.combinationId"
        />
      </a-form-item>
      <a-form-item label="秒杀产品ID" name="seckillId">
        <a-input
          allow-clear
          placeholder="请输入秒杀产品ID"
          v-model:value="form.seckillId"
        />
      </a-form-item>
      <a-form-item label="砍价id" name="bargainId">
        <a-input
          allow-clear
          placeholder="请输入砍价id"
          v-model:value="form.bargainId"
        />
      </a-form-item>
      <a-form-item label="用户ID" name="userId">
        <a-input
          allow-clear
          placeholder="请输入用户ID"
          v-model:value="form.userId"
        />
      </a-form-item>
      <a-form-item label="是否删除, 0否, 1是" name="deleted">
        <a-input
          allow-clear
          placeholder="请输入是否删除, 0否, 1是"
          v-model:value="form.deleted"
        />
      </a-form-item>
      <a-form-item label="修改时间" name="updateTime">
        <a-input
          allow-clear
          placeholder="请输入修改时间"
          v-model:value="form.updateTime"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addCart, updateCart } from '@/api/shop/cart';
  import { Cart } from '@/api/shop/cart/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: Cart | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<Cart>({
    id: undefined,
    type: undefined,
    goodsId: undefined,
    code: undefined,
    spec: undefined,
    cartNum: undefined,
    isPay: undefined,
    isNew: undefined,
    combinationId: undefined,
    seckillId: undefined,
    bargainId: undefined,
    userId: undefined
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    cartName: [
      {
        required: true,
        type: 'string',
        message: '请填写购物车名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateCart : addCart;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
